<!DOCTYPE html>
<html lang="en">

<head>
    <title> All APIs sample cho Devcamp Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<style>
    .divider {
        border-bottom: 2px solid #0163ee;
        margin-top: 2rem;
        margin-bottom: 2rem;
        width: 23rem;
    }
</style>
<script>
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_CREATE_OK = 201; // status 201 là tạo mới thành công
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    const gBASE_URL = "https://63b401c1ea89e3e3db539072.mockapi.io/api/v1/";

    /********** API FOR PRODUCTS MANAGEMENT ***********/

    // API lấy danh sách sản phẩm (Products)
    function onGetProductListClick() {
        var vAPI_URL = gBASE_URL + "/products/";
        var vXhttp = new XMLHttpRequest();
        vXhttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXhttp.responseText); // ghi response text ra console.log
            }
        };
        vXhttp.open("GET", vAPI_URL, true);
        vXhttp.send();
    }

    // API lấy chi tiết 01 product by id
    function onGetProductByIdClick() {
        const vAPI_URL = gBASE_URL + "/products/";
        var vGradeId = 11;

        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("GET", vAPI_URL + vGradeId, true);
        vXmlHttp.send();
        vXmlHttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXmlHttp.responseText);
            }
        }
    }

    // API lấy danh sách quốc gia (Countries)
    function onGetCountryListClick() {
        var vAPI_URL = gBASE_URL + "/countries/";
        var vXhttp = new XMLHttpRequest();
        vXhttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXhttp.responseText); //ghi response text ra console.log
            }
        };
        vXhttp.open("GET", vAPI_URL, true);
        vXhttp.send();
    }

    // API lấy danh sách nhóm sản phẩm (Categories)
    function onGetCategoryListClick() {
        const vAPI_URL = gBASE_URL + "/categories/";
        // create a request
        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("GET", vAPI_URL, true);
        vXmlHttp.send();
        vXmlHttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXmlHttp.responseText);
            }
        }
    }

</script>

<body>
    <div class="container mt-4">
        <div class="row form-group">
            <strong class="text-danger"> Bật console log để nhìn rõ output </strong>
        </div>
        <div class="row form-group">
            <p id="testP" class="h4"> Demo APIs cho dự án Quản lý sản phẩm: </p>
        </div>
        <div class="row form-group">
            <button  class="btn btn-info m-1" onclick="onGetProductListClick()">Lấy danh sách sản phẩm</button>
            <button  class="btn btn-warning m-1" onclick="onGetProductByIdClick()">Lấy chi tiết 1 sản phẩm theo id</button>
            <button  class="btn btn-primary m-1" onclick="onGetCountryListClick()">Lấy danh sách quốc gia</button>
            <button  class="btn btn-success m-1" onclick="onGetCategoryListClick()">Lấy danh sách nhóm sản phẩm</button>
        </div>
    </div>
</body>

</html>